//********************************************************
//         File: SetPressure.java
//       Author: HGG, updated by Dr. Spiegel
//         Date: January 2000
//     Computer: PCs and KUNet
//     Compiler: jdk1.1.8 and up
//      Purpose: To demonstrate mutual exclusion
//               The safe pressure is 20, and we can't set it 
//               any higher 
//		 pressureGuage is shared memory
//    Reference: Just Java 2
//********************************************************


public class SetPressure 
{
   static int pressureGauge = 0;
   static final int SafetyLimit = 20;
   public static void main(String [] args)
   {
      pressure [] p1 = new pressure[10];
      for(int i = 0; i < 10; i++)
      {
        p1[i] = new pressure();
        p1[i].start();
      } 
      try
      {
      for(int i = 0; i < 10; i++)
         p1[i].join();
      }
      catch (Exception e)
      {} // do nothing 
      System.out.println("Gauge reads " + pressureGauge +
                         ", safe limit is " + SafetyLimit);
   }
}

class pressure extends Thread
{ // obj is shared among all objects oftype pressure
  static Object obj = new Object();

  // static synchronized  // This is needed for safety
  void raisePressure()
  {
   // Sets a lock on obj. 
   // This thread must obtain a mutex (mutual exclusion) lock on obj before proceeding
   synchronized(obj)
   {
    if(SetPressure.pressureGauge < SetPressure.SafetyLimit - 15)
    {
      try
      {  
        sleep(5000);
      }
      catch(Exception e)
      {}
      SetPressure.pressureGauge += 15;
    }
    else ;  // pressure too high; don't increase it.
   }
  }

  public void run()
  {
    raisePressure();
  }

}
